
/*
 * Copyright 2011-2022 Cuberite Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "Globals.h"  // NOTE: MSVC stupidness requires this to be the same across all modules

#include "EnchantingTableEntity.h"
#include "../ClientHandle.h"





cEnchantingTableEntity::cEnchantingTableEntity(BLOCKTYPE a_BlockType, NIBBLETYPE a_BlockMeta, Vector3i a_Pos, cWorld * a_World, AString a_CustomName) :
	Super(a_BlockType, a_BlockMeta, a_Pos, a_World),
	m_CustomName(std::move(a_CustomName))
{
	ASSERT(a_BlockType == E_BLOCK_ENCHANTMENT_TABLE);
}





cItems cEnchantingTableEntity::ConvertToPickups() const
{
	cItem Item(E_BLOCK_ENCHANTMENT_TABLE);
	Item.m_CustomName = m_CustomName;
	return Item;
}





void cEnchantingTableEntity::CopyFrom(const cBlockEntity & a_Src)
{
	Super::CopyFrom(a_Src);

	auto & Src = static_cast<const cEnchantingTableEntity &>(a_Src);
	m_CustomName = Src.m_CustomName;
}





bool cEnchantingTableEntity::UsedBy(cPlayer * a_Player)
{
	UNUSED(a_Player);
	return true;
}





void cEnchantingTableEntity::SendTo(cClientHandle & a_Client)
{
	a_Client.SendUpdateBlockEntity(*this);
}
